import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsClasssubject {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  GradeId!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  SubjectId!: IType<number, bigint>;
  SubjectName?: string;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  SchoolId!: IType<number, bigint> & Opt;
}

export const ScsClasssubjectSchema = defineEntity({
  class: ScsClasssubject,
  comment: '班-学科关联表',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    GradeId: p.bigint().name('GradeId').columnType('bigint').comment('届'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级id'),
    SubjectId: p.bigint().name('SubjectId').columnType('bigint').comment('科目id'),
    SubjectName: p.string().name('SubjectName').nullable().comment('科目名称'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    SchoolId: p.bigint().name('SchoolId').columnType('bigint').comment('学校id').defaultRaw(`0`),
  },
});
